#!/bin/bash
# Copyright 2009, 2010, 2013 - 2015 Michal Žejdl
# run all the components

confdir=$(dirname $0)
config=$confdir/defaults.sh
test -f $config || exit
. $config

if ! mv $rundir/stopped $rundir/started 2>/dev/null; then
	echo "already running - try stop first"
	exit
fi

# here should be a dependency check (which)

# rotate while we are not running
#/usr/sbin/logrotate -s $logdir/logrotate.status $logdir/logrotate.conf

# named pipe
mkfifo $mysqlwpipe

# common way to update database
# hook mysql with write privilegies to pipe
# mysql is reading sql commands (insert, update) from the pipe and execute them
# mysql is started after pipe is opened for writing by golems below
# this bash script wait for it before exits (nice)
mysql -fnNsw --reconnect $modify_opts < $mysqlwpipe >> $logdir/mysql.out 2>> $logdir/mysql.err & echo $! > $rundir/mysql.pid

# create "šém" for each golem
for sem in $golems; do
	touch $rundir/$sem.sem
done

# pid file creation removed; (... /revisor.err & echo $! > $rundir/revisor.pid)
$netldbdir/revisor.sh >> $logdir/revisor.out 2>> $logdir/revisor.err &
$netldbdir/snmp/dispatcher.sh >> $logdir/dispatcher.out 2>> $logdir/dispatcher.err &

$coredir/fdb2graph.sh >>$logdir/fdb2graph.out 2>>$logdir/fdb2graph.err &
$coredir/rresolver.sh >> $logdir/rresolver.out 2>> $logdir/rresolver.err &
$coredir/topology.sh >> $logdir/topology.out 2>> $logdir/topology.err &
$coredir/snmp/addresses.sh >> $logdir/snmp/addresses.out 2>> $logdir/snmp/addresses.err &
$coredir/snmp/agents.sh >> $logdir/snmp/agents.out 2>> $logdir/snmp/agents.err &
$coredir/snmp/dispatcher.sh >> $logdir/snmp/dispatcher.out 2>> $logdir/snmp/dispatcher.err &
