#!/bin/bash
# Michal Žejdl 2009
# výstupem je počet ARP vysílačů za poslední období
# určeno pro snmpd, potažmo graf v NetMRG

. /usr/local/etc/mysql_prepinace

if test ! $# -eq 1; then
  echo "čekám jeden parametr - jak staré záznamy se mají počítat (v hodinách)"
  exit
fi

hodin=$1

if test ! $hodin -gt 0; then
  echo "počet hodin musí být přirozené číslo"
  exit
fi

nejstarsi=$(( $(date +%s) - $hodin * 3600 ))

# každou MAC počítat jen jednou, aby střídači IP nenavyšovali počet
mysql -e "select count(distinct(mac)) from arp where time >= '$nejstarsi'" $mysql_prepinace -Ns
