#!/bin/bash
# Copyright 2016 Michal Žejdl
# MikroTik mtxrWlStat - Strength

# at least five args are required
test $# -lt 5 && exit

rrdbasedir=$1
rrdfile=$2
outputdir=$3
starttime=$4
endtime=$5

# make the remote flush possible
cd $rrdbasedir || exit

test -d "$outputdir" || mkdir -p "$outputdir" || exit

# lazy (-z) is handy
options="-s $starttime -e $endtime -z"

# append rrdcached
test $# -gt 5 && options="$options --daemon $6"

filename=$(basename $rrdfile .rrd)

rrdtool graph \
$outputdir/mikrotik-$filename-Strength-$starttime-$endtime.png \
$options -t "Strength" -v "dBm" \
DEF:sa=$rrdfile:Strength:AVERAGE \
DEF:sn=$rrdfile:Strength:MIN \
DEF:sm=$rrdfile:Strength:MAX \
DEF:sl=$rrdfile:Strength:LAST \
VDEF:saa=sa,AVERAGE \
VDEF:snn=sn,MINIMUM \
VDEF:smm=sm,MAXIMUM \
VDEF:sll=sl,LAST \
TEXTALIGN:left \
LINE2:sa#0000cc:"" \
GPRINT:saa:"avg\: %6.2lf %s" \
GPRINT:snn:"min\: %6.2lf %s" \
GPRINT:smm:"max\: %6.2lf %s" \
GPRINT:sll:"lst\: %6.2lf %s\l"
