<?php

/*
 * Copyright 2013 - 2017 Michal Žejdl
 */

$document_root = ".";

require "$document_root/conf.php";
require "$document_root/functions.php";

date_default_timezone_set($timezone);
set_i18n($locale);

$title = gettext("IPv4 address");

page_open($document_root, $title);



if (!isset($_GET["id"]))
	exit("<p>" . gettext("the id argument is missing"));

$ipv4 = $_GET["id"];

// a validation check
if (!preg_match("/^([[:digit:]]{1,3}\.){3}[[:digit:]]{1,3}$/", $ipv4))
	exit("<p>$ipv4 " . gettext("is not valid IPv4 address"));

echo "<h1>$title $ipv4</h1>\n";

$name = try_addr2name($ipv4);
if ($name) {
	echo "<p>\n";
	echo "<h2>" . gettext("DNS name") . " $name</h2>";
}

// creating $query_limit
if (isset($_GET["nolimit"])) $query_limit = "";
else $query_limit = " limit ".$limit;

$connection = mysql_connect($dbhost, $dbuser, $dbpass);

if (!$connection)
	exit(gettext("database connection error"));

mysql_select_db($dbname);

// SNMP agent
$result = mysql_query("select agent from snmp4 where address = '$ipv4'");
if ($result)
	if (mysql_num_rows($result)) {
		$snmpagentid = mysql_result($result, 0);
		if (is_numeric($snmpagentid)) {
			echo "<p>";
			printf(gettext("There is %sSNMP agent%s on this address."), "<a href=\"snmp/agent.php?id=" . $snmpagentid . "\">",
			"</a>");
			echo "\n";
		}
	}

// ARP

$count = mysql_result(mysql_query(
			"select count(ip) from arp where ip = '$ipv4'"), 0);

if ($count > 0) {
	$result = mysql_query("select mac, time from arp
			where ip = '$ipv4' order by time desc".$query_limit);

	echo "<h2>", gettext("ARP table"), "</h2>\n";
	echo "<table summary=\"", gettext("ARP table"), "\">\n";
	echo "<tr>",
			 "<th>", gettext("MAC address"),
			 "<th>", gettext("last seen with IPv4"),
			 "\n";

	$row_number = 0;
	$timestamp = time();

	while ($row = mysql_fetch_array($result)) {
		echo "<tr class=\"monospace ",
		     tr_aging_class(++$row_number,
				     $timestamp - $row["time"]),
		     "\">",
		     "<td><a href=\"mac.php?id=", $row["mac"], "\">",
		     $row["mac"], "</a>",
		     "<td class=\"center\">", date_formated($row["time"]),
		     "\n";
	}
	echo "</table>\n";

	$num_rows = mysql_num_rows($result);
	if ($count > $num_rows) {

		echo "<p>";
		printf(gettext("number of rows: %d, %sall%s rows: %d"),
				$num_rows,
				"<a href=\"ipv4.php?id=$ipv4&nolimit=yes\">",
				"</a>",
				$count
		      );
		echo "\n";
	}
}

// the test here should be useless
preg_match("/^([[:digit:]]{1,3}\.){3}/", $ipv4, $subnet24);

echo "<h1>", gettext("free IPv4 addresses from the range");
echo " $subnet24[0]0-255</h1>";

echo "<p>";
echo gettext("Free addresses are those that have not been visible for more than three years on the network and have no DNS record.");
echo "\n";

$result = mysql_query("select *, from_unixtime(time) from arp upper
		where ip like '$subnet24[0]%' and time =
		(select max(time) from arp where ip = upper.ip)
		order by inet_aton(ip)");

$free_ip4 = false;
$row = mysql_fetch_array($result);

function free_ip4_table_header() {
	global $free_ip4;
	$free_ip4 = true;
	echo "<h2>", gettext("the free IPv4 addresses table"), "</h2>\n";
	echo "<table summary=\"", gettext("the free IPv4 addresses table");
	echo "\">\n";
	echo "<tr>";
	echo "<th>", gettext("MAC address");
	echo "<th>", gettext("IPv4 address");
	echo "<th>", gettext("time");
	echo "\n";
}

//$debug = true;
for ($i = 0; $i <= 255; $i++) {
	$ip4 = $subnet24[0].$i;
	debug_print($ip4);
	debug_print("go on");
	if ($row) {
		debug_print("we have a row");
		debug_print($row["ip"]);
		if ($row["ip"] == $ip4) {

			debug_print("this IPv4 address is in the ARP table");
			if (($row["time"] < time() - 94672800) and (try_addr2name($ip4) == "")) {
				debug_print("is more than 3 years old"
						. " and has no reverse record");
				if (!$free_ip4) free_ip4_table_header();
				echo "<tr class=\"monospace\">",
				     "<td><a href=\"mac.php?id=",
				     $row["mac"], "\">",
				     $row["mac"], "</a>",
				     "<td>", $row["ip"],
				     "<td class=\"center\">", $row["from_unixtime(time)"],
				     "\n";
			}
			debug_print("try to read next row");
			$row = mysql_fetch_array($result);
		} else {
			debug_print("we still have $i less than next row");
			if (try_addr2name($ip4) == "") {
				if (!$free_ip4) free_ip4_table_header();
				echo "<tr class=\"monospace\"><td><td>",
				     "$ip4<td>\n";
			}
		}
	} else {
		debug_print("there is no next row");
		if (try_addr2name($ip4) == "") {
			if (!$free_ip4) free_ip4_table_header();
			echo "<tr class=\"monospace\"><td><td>$ip4",
			     "<td>\n";
		}
	}
}

if ($free_ip4)
	echo "</table>\n";
else
	echo "<h2>", gettext("no free IPv4 addresses"), "</h2>\n";



page_close($document_root);

?>
