<?php

/*
 * Copyright 2013 - 2017 Michal Žejdl
 */

$document_root = ".";

require "$document_root/conf.php";
require "$document_root/functions.php";

date_default_timezone_set($timezone);
set_i18n($locale);

$title = gettext("MAC address");

page_open($document_root, $title);



function print_fdb_header()
{
	echo "<h2>", gettext("FDB table"), "</h2>\n";
}

if (!isset($_GET["id"]))
	exit("<p>" . gettext("the id argument is missing"));

$mac = $_GET["id"];
  
// a validation check
if (!preg_match("/^([[:xdigit:]]{2}:){5}[[:xdigit:]]{2}$/", $mac))
	  exit("<p>$mac " . gettext("doesn't match the expected pattern (01:23:45:67:89:ab)") . "\n");

echo "<h1>$title $mac</h1>\n";

// display MAC in other formats
$compressed_mac = str_replace(":", "", $mac);
echo "<p>\n";
echo "Cisco: ",
		 rtrim(preg_replace("/([[:xdigit:]]{4})/", "$1.", $compressed_mac), "."),
		 " | 3Com: ",
		 rtrim(preg_replace("/([[:xdigit:]]{4})/", "$1-", $compressed_mac), "-"),
		 " | ",
		 str_replace(":", "-", $mac),
		 "\n";

// creating $query_limit
if (isset($_GET["nolimit"])) $query_limit = "";
else $query_limit = " limit ".$limit;

$connection = mysql_connect($dbhost, $dbuser, $dbpass);

if (!$connection)
	exit(gettext("database connection error"));

mysql_select_db($dbname);


// ARP

$count = mysql_result(mysql_query(
			"select count(mac) from arp where mac = '$mac'"), 0);

if ($count > 0) {
	$result = mysql_query("select mac, ip, time from arp
			where mac = '$mac' order by time desc".$query_limit);

	echo "<h2>", gettext("ARP table"), "</h2>\n";
	echo "<table summary=\"", gettext("ARP table"), "\">\n";
	echo "<tr>",
			 "<th>", gettext("IPv4 address"),
			 "<th>", gettext("last seen with MAC"),
			 "<th>", gettext("corresponding DNS name"),
			 "\n";

	$row_number = 0;
	$timestamp = time();

	while ($row = mysql_fetch_array($result)) {
		echo "<tr class=\"monospace ",
		     tr_aging_class(++$row_number, $timestamp - $row["time"]),
		     "\">",
		     "<td><a href=\"ipv4.php?id=", $row["ip"], "\">",
		     $row["ip"], "</a>",
		     "<td class=\"center\">", date_formated($row["time"]),
		     "<td>", try_addr2name($row["ip"]),
		     "\n";
	}
	echo "</table>\n";

	$num_rows = mysql_num_rows($result);
	if ($count > $num_rows) {

		echo "<p>";
		printf(gettext("number of rows: %d, %sall%s rows: %d"),
				$num_rows,
				"<a href=\"mac.php?id=$mac&nolimit=yes\">",
				"</a>",
				$count
		      );
		echo "\n";
	}
}


// ND

$count = mysql_result(mysql_query(
			"select count(mac) from nd where mac = '$mac'"), 0);

if ($count > 0) {
	$result = mysql_query("select mac, ip6, time from nd
		where mac = '$mac' order by time desc".$query_limit);

	echo "<h2>", gettext("ND table"), "</h2>\n";
	echo "<table summary=\"", gettext("ND table"), "\">\n";
	echo "<tr>",
			 "<th>", gettext("IPv6 address"),
			 "<th>", gettext("last seen with MAC"),
			 "<th>", gettext("corresponding DNS name"),
			 "\n";

	$row_number = 0;
	$timestamp = time();

	while ($row = mysql_fetch_array($result)) {
		echo "<tr class=\"monospace ",
		     tr_aging_class(++$row_number, $timestamp - $row["time"]),
		     "\">",
			 "<td><a href=\"ipv6.php?id=", $row["ip6"], "\">",
			 $row["ip6"], "</a>",
			 "<td class=\"center\">", date_formated($row["time"]),
			 "<td>", try_addr2name($row["ip6"]),
			 "\n";
	}
	echo "</table>\n";

	$num_rows = mysql_num_rows($result);
	if ($count > $num_rows) {

		echo "<p>";
		printf(gettext("number of rows: %d, %sall%s rows: %d"),
				$num_rows,
				"<a href=\"mac.php?id=$mac&nolimit=yes\">",
				"</a>",
				$count
		      );
		echo "\n";
	}
}


// FDB

$result = mysql_query("select agent, port, sysName
		from fdb2graph_leafport join snmpagent on agent = id
		where mac = '$mac'");

$num_rows = mysql_num_rows($result);

if ($num_rows) {

	print_fdb_header();

	$row = mysql_fetch_array($result);

	$agent_name = empty($row["sysName"]) ?
		gettext("agent no.") . " " . $row["agent"] : $row["sysName"];

	echo "<p>";
	printf(gettext("MAC address was seen for the last time on the port %s of the switch %s."),
			"<a href=\"snmp/mib/fdbport.php?agent="
			. $row["agent"]
			. "&amp;port=" . $row["port"]
			. "\">"
			. $row["port"]
			. "</a>",
			"<a href=\"snmp/mib/fdb.php?agent="
			. $row["agent"]
			. "\">"
			. $agent_name
			. "</a>"
	      );
	echo "\n";

} else {

	$result = mysql_query("select
			mibfdbport.time time, agent, port, sysName
			from mibfdbport
			join snmpagent on agent = id
			where mac = '$mac'
			and port not in
			(select port_a from fdb2graph_neighbour
			 where agent_a = agent)
			order by time desc");

	$num_rows = mysql_num_rows($result);

	if ($num_rows > 0) {

		print_fdb_header();

		/*
		 * may be later, when fdb2graph will be improved
		 if ($num_rows == 1) {

		 $row = mysql_fetch_array($result);

		 echo "<p>";
		 echo gettext("MAC address was seen for the last time
		 on the port");
		 echo $row["port"];
		 } else
		 */

		{
			echo "<h3>";
			echo gettext("MAC address on the ports for which neighboring bridges were not found");
			echo "</h3>";
			echo "<p>\n";
			echo "<table summary=\"FdbTable\">\n";
			echo "<tr>",
			     "<th>time</th>",
			     "<th>bridge",
			     "<th>port",
			     "\n";

			$row_number = 0;
			$timestamp = time();

			while ($row = mysql_fetch_array($result)) {

				echo "<tr class=\"monospace ",
				     tr_aging_class(++$row_number,
						     $timestamp - $row["time"]),
				     "\">";

				echo "<td>", date_formated($row["time"]);

				echo "<td>";
				echo "<a href=\"snmp/mib/fdb.php?agent=";
				echo $row["agent"];
				echo "\">";
				echo $row["sysName"];
				echo "</a>";

				echo "<td class=\"right\">";
				echo "<a href=\"snmp/mib/fdbport.php?agent=";
				echo $row["agent"];
				echo "&amp;port=";
				echo $row["port"];
				echo "\">";
				echo $row["port"];
				echo "</a>";

				echo "\n";
			}

			echo "</table>\n";
		}
	}
}

// FDB - old

$count = mysql_result(mysql_query(
			"select count(mac) from fdb where mac = '$mac'"), 0);

if ($count > 0) {

	echo "<h2>";
	echo gettext("FDB table (old)");
	echo "</h2>";

	echo "<p>";
	echo gettext("This section is considered obsolete and will be removed.");
	echo "\n";

	echo "<p>";
	echo gettext("Let me know, if you wish continue to use it.");
	echo "\n";

	 /*

	 select such pairs of switch, port, which have searched MAC
	 (MAC collected only in the last hour)
	 and from this pairs choose the pair which have the fewest MAC addresses
	 (in the same last hour)

	 using subselect it was unusably slow (no index when using "in")
	 so here is Cartesian join of fdb with awkward "order by count limit 1"
	 because I does'n know how to use aggregate function min()

	 o-oh, mysql_query is only for one query

	 it may be faster to have one query with two same subselects in where
	 but I don't want to run the same query twice

	 */

	mysql_query("set @last_hour =
			(select max(time) from fdb where mac = '$mac') - 3600
			");
	$result = mysql_query("
			select switch, port from fdb as first join fdb as second
			using (switch, port)
			where first.mac = '$mac'
			and first.time >= @last_hour and second.time >= @last_hour
			group by switch, port order by count(second.mac) limit 1
			");
	$row = mysql_fetch_array($result);

	echo "<p>";
	printf(gettext("MAC address was seen for the last time on the port %s of the switch %s."),
			"<a href=\"port.php?id="
			. $row["port"]
			. "&amp;switch="
			. $row["switch"]
			. "\">"
			. $row["port"]
			. "</a>",
			"<a href=\"switch.php?id="
			. $row["switch"]
			. "\">"
			. $row["switch"]
			. "</a>"
	      );
	echo "\n";
}



page_close($document_root);

?>
